From 5e8113236654f2d1e5242580b80fded704531a44 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 23 2018 16:41:37 +0000
Subject: [PATCH 39/48] use TreeObj/RPMsMixin based classes in ModuleMetadata


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 48d1ee9..6ed8119 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -659,12 +659,9 @@ class ModuleMetadata(object):
     @property
     def profiles(self):
         """A dictionary property representing the module profiles."""
-        # TODO: return the profiles as a dict of ModuleProfile types
-        d = dict()
-        for k, v in self.module.get_profiles().items():
-            d[k] = ModuleProfile(profile=v, parent=self, name=k)
-
-        return d
+        return {k: ModuleProfile._new_from_native(native_profile=v,
+                                                  bound=True, parent=self)
+                for k, v in self.module.get_profiles().items()}
 
     @profiles.setter
     def profiles(self, d):
@@ -674,101 +671,82 @@ class ModuleMetadata(object):
             if not isinstance(k, str) or not isinstance(v, ModuleProfile):
                 raise TypeError("profiles: data type not supported")
 
-        profiles = self.module.get_profiles()
-
+        # ensure keys and names in profiles agree
         for k, v in d.items():
-            profile = Modulemd.Profile()
-            if v.description:
-                profile.set_description(v.description)
+            v.name = k
 
-            ss = Modulemd.SimpleSet()
-            ss.set(list(v.rpms))
+        self.module.set_profiles({k: v._to_native() for k, v in d.items()})
 
-            profile.set_rpms(ss)
-            profiles[k] = profile
-        self.module.set_profiles(profiles)
+    @property
+    def tree_objs(self):
+        if not hasattr(self, '_tree_objs'):
+            self._tree_objs = {
+                'api': ModuleAPI(parent=self),
+                'filter': ModuleFilter(parent=self),
+                'buildopts': ModuleBuildopts(parent=self),
+                'components': ModuleComponents(parent=self),
+                'artifacts': ModuleArtifacts(parent=self),
+            }
+        return self._tree_objs
 
     @property
     def api(self):
         """A ModuleAPI instance representing the module's public API."""
-        api = ModuleAPI(parent=self)
-        api.rpms = set(self.module.get_rpm_api().get())
-        return api
+        return self.tree_objs['api']
 
     @api.setter
     def api(self, o):
         if not isinstance(o, ModuleAPI):
             raise TypeError("api: data type not supported")
 
-        rpms = Modulemd.SimpleSet()
-        rpms.set(list(o.rpms))
-
-        self.module.set_rpm_api(rpms)
+        self.tree_objs['api'].replace(o)
 
     @property
     def filter(self):
         """A ModuleFilter instance representing the module's filter."""
-        filter = ModuleFilter(parent=self)
-        filter.rpms = set(self.module.get_rpm_filter().get())
-        return filter
+        return self.tree_objs['filter']
 
     @filter.setter
     def filter(self, o):
         if not isinstance(o, ModuleFilter):
             raise TypeError("filter: data type not supported")
 
-        rpms = Modulemd.SimpleSet()
-        rpms.set(list(o.rpms))
-
-        self.module.set_rpm_filter(rpms)
+        self.tree_objs['filter'].replace(o)
 
     @property
     def buildopts(self):
         """A ModuleBuildopts instance representing the additional
         module components build options.
         """
-        if not getattr(self, '_buildopts', None):
-            self.buildopts = ModuleBuildopts(parent=self)
-        return self._buildopts
+        return self.tree_objs['buildopts']
 
     @buildopts.setter
     def buildopts(self, o):
         if not isinstance(o, ModuleBuildopts):
             raise TypeError("buildopts: data type not supported")
-        self._buildopts = o
+
+        self.tree_objs['buildopts'].replace(o)
 
     @property
     def components(self):
         """A ModuleComponents instance property representing the components
         defining the module.
         """
-        if not hasattr(self, '_components'):
-            self._components = ModuleComponents(parent=self)
-        self._components.rpms = self.module.get_rpm_components()
-        self._components.modules = self.module.get_module_components()
-        return self._components
+        return self.tree_objs['components']
 
     @components.setter
     def components(self, o):
         if not isinstance(o, ModuleComponents):
             raise TypeError("components: data type not supported")
-
-        self.module.set_rpm_components(o.rpms)
-        self.module.set_module_components(o.modules)
+        self.tree_objs['components'].replace(o)
 
     @property
     def artifacts(self):
         """A ModuleArtifacts instance representing the module's artifacts."""
-        artifacts = ModuleArtifacts(parent=self)
-        artifacts.rpms = set(self.module.get_rpm_artifacts().get())
-        return artifacts
+        return self.tree_objs['artifacts']
 
     @artifacts.setter
     def artifacts(self, o):
         if not isinstance(o, ModuleArtifacts):
             raise TypeError("artifacts: data type not supported")
-
-        rpms = Modulemd.SimpleSet()
-        rpms.set(list(o.rpms))
-
-        self.module.set_rpm_artifacts(rpms)
+        self.tree_objs['artifacts'].replace(o)

